#import <objectbase/Swarm.h>
#import <gui.h>
#import "BoidSpace.h"

@interface ModelSwarm: Swarm
{
  int numAgents;
  int numObstacles;
  int worldXSize, worldYSize;
  int agentID;

  id <List> objectList;

  id <Canvas> canvas;

  id modelActions;
  id modelSchedule;

  int **visibilityMatrix;
  int boidCount; 
  // Total number of boids that have been created so far. Note that this
  // value increases monotonically, and does NOT take into account boids
  // that have been deleted.


  id boidSpace;

  id <Raster> boidRaster;

/*   char* useBoidRaster; */
/*   char* useBoidCanvas; */

  BOOL useBoidRaster;
  BOOL useBoidCanvas;


}

+ create: aZone;

- buildObjects;
- buildBoidSpace;


- buildActions;
- activateIn: (id) swarmContext;

- displayCanvasObjects;
- setBoidCanvas: (id <Canvas>) c;
- setBoidRaster: (id <Raster>) aRaster;
- (id <Canvas>) getBoidCanvas;
- (id <List>) getObjectList;




//
// GET METHODS
//
- (int)getWorldXSize;
- (int)getWorldYSize;


- getBoidSpace;
- getBoids;


- (BOOL) useBoidRaster;
- (BOOL) useBoidCanvas;

@end
